diff -r b7fe7a985a62 src/medfilt1.cc
--- a/src/medfilt1.cc	Wed Oct 03 12:31:40 2018 -0700
+++ b/src/medfilt1.cc	Sat Dec 29 18:48:35 2018 +0100
@@ -35,19 +35,8 @@
 #include "error.h"
 #include "ov.h"
 
-#include "octave-compat.h"
-
-enum nan_opt_type
-{
-  NAN_OPT_INCLUDE,
-  NAN_OPT_OMIT
-};
-
-enum pad_opt_type
-{
-  PAD_OPT_ZERO,
-  PAD_OPT_TRUNCATE
-};
+enum nan_handling { include_nan, omit_nan };
+enum pad_type { zero_pad, truncate };
 
 // Keep a sorted sliding window of values.
 // There is no error checking, to keep things fast.
@@ -222,13 +211,13 @@
                     octave_idx_type leading, octave_idx_type trailing,
                     octave_idx_type start_middle, octave_idx_type end_middle,
                     octave_idx_type last, octave_idx_type initial_fill,
-                    pad_opt_type pad_opt, sorted_window& sw)
+                    pad_type padding, sorted_window& sw)
 {
   sw.init (x, initial_fill, stride,
-           (pad_opt == PAD_OPT_ZERO) ? (n - initial_fill) : 0);
+           (padding == zero_pad) ? (n - initial_fill) : 0);
 
   // Partial window at the start
-  if (pad_opt == PAD_OPT_ZERO)
+  if (padding == zero_pad)
     for (octave_idx_type i = 0; i < start_middle; i += stride)
       {
         sw.replace (x[i + leading], 0);
@@ -257,7 +246,7 @@
     }
 
   // Partial window at the end
-  if (pad_opt == PAD_OPT_ZERO)
+  if (padding == zero_pad)
     for (octave_idx_type i = end_middle; i < last; i += stride)
       {
         sw.replace (0, x[i - trailing]);
@@ -306,8 +295,8 @@
     print_usage ();
 
   octave_idx_type n = 3, dim = 0;
-  nan_opt_type nan_opt = NAN_OPT_INCLUDE;
-  pad_opt_type pad_opt = PAD_OPT_ZERO;
+  nan_handling nan_flag = include_nan;
+  pad_type     padding  = zero_pad;
 
   int nargin = args.length ();
 
@@ -323,9 +312,9 @@
 
       std::string s = args(nargin - 1).string_value ();
       if (! strcasecmp (s.c_str (), "omitnan"))
-        nan_opt = NAN_OPT_OMIT;
+        nan_flag = omit_nan;
       else if (! strcasecmp (s.c_str (), "truncate"))
-        pad_opt = PAD_OPT_TRUNCATE;
+        padding = truncate;
       else if (strcasecmp (s.c_str (), "includenan")
                && strcasecmp (s.c_str (), "zeropad"))  // the defaults
         error ("medfilt1: Invalid NAN_FLAG or PADDING value '%s'", s.c_str ());
@@ -335,9 +324,9 @@
 
   if (nargin >= 2)
     {
-      if (octave::signal::isnumeric (args(1)))
+      if (args(1).isnumeric ())
         {
-          if (args(1).numel () != 1 || octave::signal::iscomplex (args(1)))
+          if (args(1).numel () != 1 || args(1).iscomplex ())
             error ("medfilt1: N must be a real scalar");
           else
             n = args(1).idx_type_value ();
@@ -347,11 +336,11 @@
                args(1).type_name ().c_str ());
     if (nargin >= 4)
       {
-        if (octave::signal::isnumeric (args(3)))
+        if (args(3).isnumeric ())
           {
             if (args(3).numel () != 1)
               error ("medfilt1: DIM must be a scalar");
-            else if (octave::signal::iscomplex (args(3)))
+            else if (args(3).iscomplex ())
               error ("medfilt1: DIM must be real");
 
             dim = round (args(3).double_value ());
@@ -397,7 +386,7 @@
     double *p_in = x.fortran_vec ();
     double *p_out = retval.fortran_vec ();
 
-    sorted_window sw (n, nan_opt == NAN_OPT_OMIT);
+    sorted_window sw (n, nan_flag);
 
     // how far ahead should data be put in window
     octave_idx_type leading = ((n - 1) / 2) * x_stride;
@@ -445,7 +434,7 @@
         medfilt1_vector (p_in + x_offset, p_out + x_offset, n, x_len,
                             x_offset, x_stride, leading, trailing,
                             start_middle, end_middle, last, initial_fill,
-                            pad_opt, sw);
+                            padding, sw);
         if (x_stride == 1)
           x_offset += x_len;
         else
diff -r b7fe7a985a62 src/upfirdn.cc
--- a/src/upfirdn.cc	Wed Oct 03 12:31:40 2018 -0700
+++ b/src/upfirdn.cc	Sat Dec 29 18:48:35 2018 +0100
@@ -22,11 +22,10 @@
 #include <octave/defun-dld.h>
 #include <octave/error.h>
 #include <octave/pager.h>
+#include <octave/errwarn.h>
 #include <octave/quit.h>
 #include <octave/variables.h>
 
-#include "octave-compat.h"
-
 template<class MT>
 MT upfirdn (MT &x, ColumnVector &h, octave_idx_type p, octave_idx_type q)
 {
@@ -131,7 +130,7 @@
     }
 
   // Do the dispatching
-  if (octave::signal::isreal (args (0)))
+  if (args (0).isreal ())
     {
       Matrix x = args (0).matrix_value ();
       if (error_state)
@@ -143,7 +142,7 @@
       Matrix y = upfirdn (x, h, p, q);
       retval (0) = y;
     }
-  else if (octave::signal::iscomplex (args (0)))
+  else if (args (0).iscomplex ())
     {
       ComplexMatrix x = args (0).complex_matrix_value ();
       if (error_state)